SystemOrganization addCategory: #UnusedObject!
SystemOrganization addCategory: #'UnusedObject-VMMaker'!
SystemOrganization addCategory: #'UnusedObject-VMMaker-Override'!
SystemOrganization addCategory: #'UnusedObject-Override-VMMaker'!

!Class methodsFor: '*UnusedObject' stamp: 'Mariano 5/11/2010 17:16'!
amountOfusedInstances
	| usedInst |
	usedInst := 0.
	self allInstancesDo: [:inst | (UnusedObjectDiscoverer current primitiveGetUsedBit: inst) ifTrue: [usedInst := usedInst + 1 ]  ]. 
	^ usedInst.! !

!Class methodsFor: '*UnusedObject' stamp: 'MarianoMartinezPeck 8/25/2010 12:08'!
hasUsedInstances 
	self allInstancesDo: [:inst | (UnusedObjectDiscoverer current primitiveGetUsedBit: inst) ifTrue: [^ true ]  ]. 
	^ false.! !

!Class methodsFor: '*UnusedObject' stamp: 'MarianoMartinezPeck 9/24/2010 11:11'!
propertyHasUsedInstances 
	self allInstancesDo: [:inst | (UnusedObjectDiscoverer current primitiveGetUsedBit: inst) ifTrue: [^ 	'Class with some instances used' ]  ]. 
	^ 'Class with no instances used' ! !

!Class methodsFor: '*UnusedObject' stamp: 'MarianoMartinezPeck 9/23/2010 11:04'!
propertyInstancesAmount
	| usedInstanceCount unusedInstanceCount |
	usedInstanceCount := 0.
	unusedInstanceCount := 0.
	self isAbstractClass ifTrue: [ ^ 0. ].
	self allInstancesDo: [:inst | (UnusedObjectDiscoverer current primitiveGetUsedBit: inst) ifTrue: [ usedInstanceCount := usedInstanceCount + 1  ] ifFalse: [ unusedInstanceCount := unusedInstanceCount +1  ]  ]. 
	^ usedInstanceCount.
	
! !

!Class methodsFor: '*UnusedObject' stamp: 'MarianoMartinezPeck 9/24/2010 11:03'!
propertyInstancesStates
	| usedInst |
	usedInst := 0.
	self isAbstractClass ifTrue: [
		(UnusedObjectDiscoverer current primitiveGetUsedBit: self) 
			ifTrue: [ ^ 'Abstract used class' ] 
			ifFalse: [ ^ 'Abstract unused class'].
		].
	self allInstancesDo: [:inst | (UnusedObjectDiscoverer current primitiveGetUsedBit: inst) ifTrue: [^  'Class with used instances'  ] ifFalse: [ ^ 'Class with instances']  ]. 
	^ 'Class without instances'.! !

!Class methodsFor: '*UnusedObject' stamp: 'MarianoMartinezPeck 9/24/2010 11:54'!
propertyInstancesStatesAndAmount
	| usedInstanceCount unusedInstanceCount |
	usedInstanceCount := 0.
	unusedInstanceCount := 0.
	self isAbstractClass ifTrue: [
		(UnusedObjectDiscoverer current primitiveGetUsedBit: self) 
			ifTrue: [ ^ 'Abstract used class' ] 
			ifFalse: [ ^ 'Abstract unused class'].
		].
	self instanceCount = 0 ifTrue: [ ^ 'Class without instances'].
	self allInstancesDo: [:inst | (UnusedObjectDiscoverer current primitiveGetUsedBit: inst) ifTrue: [ usedInstanceCount := usedInstanceCount + 1  ] ifFalse: [ unusedInstanceCount := unusedInstanceCount +1  ]  ]. 
	(usedInstanceCount = 0) ifTrue: [ ^ 'Class with instances but unused']. 
	(usedInstanceCount between:  1 and: 10) ifTrue: [^ 'Class with used instances between 1 and 10'].
	(usedInstanceCount between:  11 and: 100) ifTrue: [^ 'Class with used instances between11 and 100'].
	(usedInstanceCount between:  101 and: 1000) ifTrue: [^ 'Class with used instances between 101 and 1000'].	
	(usedInstanceCount between:  1001 and: 10000) ifTrue: [^ 'Class with used instances between 1001 and 10000'].	
	(usedInstanceCount between:  10001 and: 100000) ifTrue: [^ 'Class with used instances between 10001 and 100000'].	
	(usedInstanceCount between:  100001 and: 1000000) ifTrue: [^ 'Class with used instances between 100001 and 1000000'].	
	  
	
	
! !

!Class methodsFor: '*UnusedObject' stamp: 'MarianoMartinezPeck 9/22/2010 12:46'!
propertyInstancesStatesAndMemory
	| usedInstanceMemory  |
	usedInstanceMemory := 0.
	self isAbstractClass ifTrue: [
		(UnusedObjectDiscoverer current primitiveGetUsedBit: self) 
			ifTrue: [ ^ 'Abstract used class' ] 
			ifFalse: [ ^ 'Abstract not used class'].
		].
	self instanceCount = 0 ifTrue: [ ^ 'No instances'].
	self allInstancesDo: [:inst | (UnusedObjectDiscoverer current primitiveGetUsedBit: inst) ifTrue: [ usedInstanceMemory := usedInstanceMemory + inst sizeInMemory  ] ]. 
	(usedInstanceMemory = 0) ifTrue: [ ^ 'Has instances but not used']. 
	(usedInstanceMemory between:  1 and: 10) ifTrue: [^ 'Used instances memory between 1 and 10 bytes'].
	(usedInstanceMemory between:  11 and: 100) ifTrue: [^ 'Used instances memory between11 and 100 bytes'].
	(usedInstanceMemory between:  101 and: 1000) ifTrue: [^ 'Used instances memory between 101 and 1000 bytes'].	
	(usedInstanceMemory between:  1001 and: 10000) ifTrue: [^ 'Used instances memory between 1001 and 10000 bytes'].	
	(usedInstanceMemory between:  10001 and: 100000) ifTrue: [^ 'Used instances memory between 10001 and 100000 bytes'].	
	(usedInstanceMemory between:  100001 and: 1000000) ifTrue: [^ 'Used instances memory between 100001 and 1000000 bytes'].	
	(usedInstanceMemory between:  1000001 and: 10000000) ifTrue: [^ 'Used instances memory between 1000001 and 10000000 bytes'].	
	  
	
	
! !

!CompiledMethod methodsFor: '*UnusedObject' stamp: 'MarianoMartinezPeck 9/24/2010 11:38'!
propertyIsUsed
	(UnusedObjectDiscoverer current primitiveGetUsedBit: self) 
			ifTrue: [ ^ 'Used method' ] 
			ifFalse: [ ^ 'Unused method'].
	! !

SpaceTally subclass: #SpaceTallyUsedObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnusedObject'!

!SpaceTallyUsedObjects methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/21/2010 17:09'!
printSpaceAnalysis	
	"SpaceTally new printSpaceAnalysis"

	| stream |
	stream := FileStream newFileNamed: 'STUsedspace.text'.
	[ self printSpaceAnalysis: 1 on: stream ] ensure: [ stream close ]! !

!SpaceTallyUsedObjects methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/21/2010 17:08'!
printSpaceAnalysis: threshold on: aStream
	"SpaceTally new printSpaceAnalysis: 1 on:(FileStream forceNewFileNamed: 'STspace.text')"

	"sd-This method should be rewrote to be more coherent within the rest of the class 
	ie using preAllocate and spaceForInstanceOf:"

	"If threshold > 0, then only those classes with more than that number
	of instances will be shown, and they will be sorted by total instance space.
	If threshold = 0, then all classes will appear, sorted by name."

	| totalCodeSpace totalInstCount totalInstSpace n totalPercent |
	Smalltalk garbageCollect.
	totalCodeSpace := totalInstCount := totalInstSpace := n := 0.
	results := OrderedCollection new: Smalltalk classNames size.
	'Taking statistics...'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: Smalltalk classNames size
		during: [:bar |
		(Smalltalk globals allClasses) do:
			[:cl | | codeSpace instCount instSpace eltSize | 
			codeSpace := cl spaceUsed.
			bar value: (n := n+1).
			Smalltalk garbageCollectMost.
			instCount := cl amountOfusedInstances.  
			instSpace := self spaceForUsedInstancesOf: cl withInstanceCount: instCount.
			results add: (SpaceTallyItem analyzedClassName: cl name codeSize: codeSpace instanceCount:  instCount spaceForInstances: instSpace).
			totalCodeSpace := totalCodeSpace + codeSpace.
			totalInstCount := totalInstCount + instCount.
			totalInstSpace := totalInstSpace + instSpace]].
		totalPercent := 0.0.

	"aStream timeStamp."
	aStream
		nextPutAll: ('Class' padded: #right to: 30 with: $ );
		nextPutAll: ('code space' padded: #left to: 12 with: $ );
		nextPutAll: ('# used instances' padded: #left to: 12 with: $ );
		nextPutAll: ('used inst space' padded: #left to: 12 with: $ );
		nextPutAll: ('percent' padded: #left to: 8 with: $ ); cr.

	threshold > 0 ifTrue: [
		"If inst count threshold > 0, then sort by space"
		results := (results select: [:s | s instanceCount >= threshold or: [s spaceForInstances > (totalInstSpace // 500)]])
			asSortedCollection: [:s :s2 | s spaceForInstances > s2 spaceForInstances]].

	results do: [:s | | percent |
		aStream
			nextPutAll: (s analyzedClassName padded: #right to: 30 with: $ );
			nextPutAll: (s codeSize printString padded: #left to: 12 with: $ );
			nextPutAll: (s instanceCount printString padded: #left to: 12 with: $ );
			nextPutAll: (s spaceForInstances printString padded: #left to: 14 with: $ ).
		percent := s spaceForInstances*100.0/totalInstSpace roundTo: 0.1.
		totalPercent := totalPercent + percent.
		percent >= 0.1 ifTrue: [
			aStream nextPutAll: (percent printString padded: #left to: 8 with: $ )].
		aStream cr].

	aStream
		cr; nextPutAll: ('Total' padded: #right to: 30 with: $ );
		nextPutAll: (totalCodeSpace printString padded: #left to: 12 with: $ );
		nextPutAll: (totalInstCount printString padded: #left to: 12 with: $ );
		nextPutAll: (totalInstSpace printString padded: #left to: 14 with: $ );
		nextPutAll: ((totalPercent roundTo: 0.1) printString padded: #left to: 8 with: $ ).! !

!SpaceTallyUsedObjects methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/21/2010 20:21'!
spaceForUsedInstancesOf: aClass withInstanceCount: instCount
	"Answer the number of bytes consumed by all instances of the given class, including their object headers."

	| isCompact instVarBytes bytesPerElement headerBytes total |
	instCount = 0 ifTrue: [^ 0].
	isCompact := aClass indexIfCompact > 0.
	instVarBytes := aClass instSize * 4.
	aClass isVariable
		ifTrue: [
			bytesPerElement := aClass isBytes ifTrue: [1] ifFalse: [4].
			total := 0.
			aClass allInstancesDo: [:inst | | contentBytes |
				contentBytes := instVarBytes + (inst basicSize * bytesPerElement).
				headerBytes :=
					contentBytes > 255
						ifTrue: [12]
						ifFalse: [isCompact ifTrue: [4] ifFalse: [8]].
					(UnusedObjectDiscoverer current primitiveGetUsedBit: inst) ifTrue: 
				[total := total + headerBytes + contentBytes]].
			^ total]
		ifFalse: [
			headerBytes :=
				instVarBytes > 255
					ifTrue: [12]
					ifFalse: [isCompact ifTrue: [4] ifFalse: [8]].
			^ instCount * (headerBytes + instVarBytes)].
! !

TestCase subclass: #UnusedObjectDiscovererTestCase
	instanceVariableNames: 'objectsToClean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnusedObject'!

!UnusedObjectDiscovererTestCase methodsFor: 'running' stamp: 'MarianoMartinezPeck 10/3/2010 11:31'!
setUp
	| unUsed |
	unUsed := UnusedObjectDiscoverer new.
	unUsed primitiveSetHasToTrace: true.
	unUsed primitiveUnmarkAllObjects.
! !

!UnusedObjectDiscovererTestCase methodsFor: 'running' stamp: 'MarianoMartinezPeck 10/3/2010 11:31'!
tearDown 
	| unUsed |
	unUsed := UnusedObjectDiscoverer new.
	unUsed primitiveSetHasToTrace: true.
	unUsed primitiveUnmarkAllObjects.
	unUsed primitiveSetHasToTrace: false.! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'Mariano 5/12/2010 16:51'!
testClassUsedInstances
	| unUsed anObject amount1 amount2 |
	
	Smalltalk garbageCollect.
	
	unUsed := UnusedObjectDiscoverer new.
	unUsed primitiveUnmarkAllObjects.
	unUsed primitiveSetHasToTrace: true.
	
	"I took a not very used class because in such case even the following line can fail."
	self deny: Stopwatch hasUsedInstances. 
	
	anObject := Stopwatch new.
	unUsed primitiveSetUsedBit: anObject boolean: false.
	self deny: (unUsed primitiveGetUsedBit: anObject).
	anObject asString.
	self assert: Stopwatch hasUsedInstances. 
	amount1 := Stopwatch amountOfusedInstances.
	
	anObject := Stopwatch new.
	unUsed primitiveSetUsedBit: anObject boolean: false.
	self deny: (unUsed primitiveGetUsedBit: anObject).
	anObject asString.
	self assert: Stopwatch hasUsedInstances. 
	amount2 := Stopwatch amountOfusedInstances.
	
	self assert: amount2 > amount1
	! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'Mariano 5/4/2010 20:07'!
testGetStadistics
	UnusedObjectDiscoverer analyse: [].
	! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'Mariano 4/29/2010 16:59'!
testGetUsedBitNormalObjects
	| unUsed |
	unUsed := UnusedObjectDiscoverer new.
	unUsed primitiveGetUsedBit: 'mariano'.
	unUsed primitiveGetUsedBit: Date new.
	unUsed primitiveGetUsedBit: 14/8.
	unUsed primitiveGetUsedBit: 999999999999999999.
	
	unUsed primitiveGetUsedBit: 'mariano'.
	unUsed primitiveGetUsedBit: Date new.
	unUsed primitiveGetUsedBit: 14/8.
	unUsed primitiveGetUsedBit: 999999999999999999.! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'Mariano 3/31/2010 14:29'!
testGetUsedSmallInteger
	| unUsed |
	unUsed := UnusedObjectDiscoverer new.
	self should: [unUsed primitiveGetUsedBit: 42] raise: Error.
	self should: [unUsed primitiveGetUsedBit: 24] raise: Error.
	self should: [unUsed primitiveGetUsedBit: 100] raise: Error.
		
! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'Mariano 5/11/2010 17:19'!
testMarkAllObjects
	| unUsed obj1 obj2 obj3 obj4 |
	
	unUsed := UnusedObjectDiscoverer new.
	obj1 := 'anObject'.
	unUsed primitiveUnmarkAsUsed: obj1.
	obj2 := 'anotherObject'.
	unUsed primitiveUnmarkAsUsed: obj2.
	obj3 := Time now.
	unUsed primitiveUnmarkAsUsed: obj3.
	obj4 := 9999999999999999999999.
	unUsed primitiveUnmarkAsUsed: obj4.

	unUsed primitiveMarkAllObjects.
	
	self assert: (unUsed primitiveGetUsedBit: obj1).
	self assert: (unUsed primitiveGetUsedBit: obj2).
	self assert: (unUsed primitiveGetUsedBit: obj3).
	self assert: (unUsed primitiveGetUsedBit: obj4).
	
	
! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/3/2010 11:31'!
testSetAndGetMultipleTimes
	| unUsed unusedObject|
	unusedObject := 'mariano'.
	unUsed := UnusedObjectDiscoverer new.
	unUsed primitiveSetUsedBit: unusedObject boolean: false.
	unUsed primitiveSetUsedBit: unusedObject boolean: false.
	unUsed primitiveSetUsedBit: unusedObject boolean: false.
	self deny: (unUsed primitiveGetUsedBit: unusedObject).
	unUsed primitiveSetUsedBit: unusedObject boolean: true.
	unUsed primitiveSetUsedBit: unusedObject boolean: true.
	unUsed primitiveSetUsedBit: unusedObject boolean: true.
	self assert: (unUsed primitiveGetUsedBit: unusedObject).
	unUsed primitiveSetUsedBit: unusedObject boolean: false.
	unUsed primitiveSetUsedBit: unusedObject boolean: false.
	unUsed primitiveSetUsedBit: unusedObject boolean: false.! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/3/2010 11:33'!
testSetAndGetUsedBitAutomaticallyFor
	| unUsed anObject|
	
	unUsed := UnusedObjectDiscoverer new.
	unUsed primitiveSetHasToTrace: true.
	anObject := 'mariano'.
	unUsed primitiveSetUsedBit: anObject boolean: false.
	self deny: (unUsed primitiveGetUsedBit: anObject).
	" I can send any message "
	anObject size. 
	self assert: (unUsed primitiveGetUsedBit: anObject).
	anObject withCRs.
	self assert: (unUsed primitiveGetUsedBit: anObject).! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/3/2010 11:31'!
testSetAndGetUsedBitAutomaticallyForCompiledMethod
	| unUsed anObject|
	
	unUsed := UnusedObjectDiscoverer new.
	anObject := Date>> #yyyymmdd.
	unUsed primitiveSetUsedBit: anObject boolean: false.
	
	unUsed primitiveSetHasToTrace: true.
	self deny: (unUsed primitiveGetUsedBit: anObject).
	self deny: (unUsed primitiveGetUsedBit: (Date>> #yyyymmdd)).
	
	anObject asString. 
	self assert: (unUsed primitiveGetUsedBit: anObject).
	self assert: (unUsed primitiveGetUsedBit: (Date>> #yyyymmdd)).
	
	anObject allLiterals.
	self assert: (unUsed primitiveGetUsedBit: anObject).
	
	
! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/3/2010 11:31'!
testSetAndGetUsedBitAutomaticallyForCompiledMethod2
	| unUsed anObject|
	
	unUsed := UnusedObjectDiscoverer new.
	anObject := Date>> #yyyymmdd.
	unUsed primitiveSetUsedBit: anObject boolean: false.
	self deny: (unUsed primitiveGetUsedBit: anObject).

	unUsed primitiveSetHasToTrace: true.

	Date today yyyymmdd.

	self assert: (unUsed primitiveGetUsedBit: anObject).
	self assert: (unUsed primitiveGetUsedBit: (Date>> #yyyymmdd)).
	
	anObject allLiterals.
	self assert: (unUsed primitiveGetUsedBit: anObject).
	
	
! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/3/2010 11:33'!
testSetAndGetUsedBitAutomaticallyForCompiledMethod3
	| unUsed anObject|
	
	unUsed := UnusedObjectDiscoverer new.
	anObject := Date today.
	unUsed primitiveSetUsedBit: anObject boolean: false.
	unUsed primitiveSetUsedBit: (anObject class >> #yyyymmdd) boolean: false.
	
	unUsed primitiveSetHasToTrace: true.
	
	self deny: (unUsed primitiveGetUsedBit: anObject).
	self deny: (unUsed primitiveGetUsedBit: (anObject class >> #yyyymmdd)).
	
	 anObject yyyymmdd.

	self assert: (unUsed primitiveGetUsedBit: anObject).
	self assert: (unUsed primitiveGetUsedBit: (anObject class >> #yyyymmdd)).
	
	
! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/3/2010 11:32'!
testSetAndGetUsedBitAutomaticallyWithoutTracing
	| unUsed anObject|
	
	unUsed := UnusedObjectDiscoverer new.
	unUsed primitiveSetHasToTrace: false.
	anObject := 'mariano'.
	unUsed primitiveSetUsedBit: anObject boolean: false.
	self deny: (unUsed primitiveGetUsedBit: anObject).
	" I can send any message "
	anObject size. 
	self deny: (unUsed primitiveGetUsedBit: anObject).
	anObject withCRs.
	self deny: (unUsed primitiveGetUsedBit: anObject).
	
	! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/3/2010 11:31'!
testSetAndGetUsedBitManuallyFor: anObject
	| unUsed |
	
	unUsed := UnusedObjectDiscoverer new.
	unUsed primitiveSetUsedBit: anObject boolean: false.
	self deny: (unUsed primitiveGetUsedBit: anObject).
	unUsed primitiveSetUsedBit: anObject boolean: true.
	self assert: (unUsed primitiveGetUsedBit: anObject).
	unUsed primitiveSetUsedBit: anObject boolean: false.
	
	! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'Mariano 4/1/2010 16:46'!
testSetAndGetUsedBitNormalObjects

	self testSetAndGetUsedBitManuallyFor: 'mariano'.
	self testSetAndGetUsedBitManuallyFor: Date new.
	self testSetAndGetUsedBitManuallyFor: 14/8.
	self testSetAndGetUsedBitManuallyFor: 999999999999999999.
	self testSetAndGetUsedBitManuallyFor: nil.! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'Mariano 4/1/2010 17:22'!
testSetUsedBitIncorrectParameter
	| unUsed |
	unUsed := UnusedObjectDiscoverer new.
   	self should: [unUsed primitiveSetUsedBit: (objectsToClean add: 'mariano') boolean: 'nonBoolean'] raise: Error.
   	self should: [unUsed primitiveSetUsedBit: (objectsToClean add: 'mariano') boolean: 42] raise: Error.
   	self should: [unUsed primitiveSetUsedBit: (objectsToClean add: 'mariano') boolean: Date new] raise: Error.
	self should: [unUsed primitiveSetUsedBit: (objectsToClean add: 'mariano') boolean: 9/8] raise: Error.
	self should: [unUsed primitiveSetUsedBit: (objectsToClean add: 'mariano') boolean: nil] raise: Error.
	self should: [unUsed primitiveSetUsedBit: (objectsToClean add: nil) boolean: nil] raise: Error.
! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'MarianoMartinezPeck 10/3/2010 11:32'!
testSetUsedBitNormalObject
	| unUsed |
	unUsed := UnusedObjectDiscoverer new.
	unUsed primitiveSetUsedBit: 'mariano' boolean: true.
	unUsed primitiveSetUsedBit: 'nose' boolean: false.
	unUsed primitiveSetUsedBit: nil boolean: false.
		
! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'Mariano 3/31/2010 14:31'!
testSetUsedBitSmallInteger
	| unUsed |
	unUsed := UnusedObjectDiscoverer new.
	self should: [unUsed primitiveSetUsedBit: 42 boolean: true] raise: Error.
	self should: [unUsed primitiveSetUsedBit: 22 boolean: true] raise: Error.
	self should: [unUsed primitiveSetUsedBit: 102 boolean: true] raise: Error.
	
	self should: [unUsed primitiveSetUsedBit: 42 boolean: false] raise: Error.
	self should: [unUsed primitiveSetUsedBit: 22 boolean: false] raise: Error.
	self should: [unUsed primitiveSetUsedBit: 102 boolean: false] raise: Error.
	
! !

!UnusedObjectDiscovererTestCase methodsFor: 'tests' stamp: 'Mariano 4/29/2010 15:29'!
testUnmarkAllObjects
	| unUsed obj1 obj2 obj3 obj4 |
	
	unUsed := UnusedObjectDiscoverer new.
	obj1 := 'anObject'.
	unUsed primitiveMarkAsUsed: obj1.
	obj2 := 'anotherObject'.
	unUsed primitiveMarkAsUsed: obj2.
	obj3 := Time now.
	unUsed primitiveMarkAsUsed: obj3.
	obj4 := 9999999999999999999999.
	unUsed primitiveMarkAsUsed: obj4.

	unUsed primitiveUnmarkAllObjects.
	
	self deny: (unUsed primitiveGetUsedBit: obj1).
	self deny: (unUsed primitiveGetUsedBit: obj2).
	self deny: (unUsed primitiveGetUsedBit: obj3).
	self deny: (unUsed primitiveGetUsedBit: obj4).
	
	! !

!MethodContext class methodsFor: '*UnusedObject' stamp: 'Mariano 5/12/2010 12:10'!
allInstancesDo: aBlock
	"Only count until thisContext"
	| inst next |
	inst := self someInstance.
	[inst == thisContext] whileFalse:[
		next := inst nextInstance.
		aBlock value: inst.
		inst := next]! !

Object subclass: #UnusedObjectDiscoverer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnusedObject'!

UnusedObjectDiscoverer class
	instanceVariableNames: 'Current'!

UnusedObjectDiscoverer class
	instanceVariableNames: 'Current'!

!UnusedObjectDiscoverer class methodsFor: 'as yet unclassified' stamp: 'Mariano 5/4/2010 20:10'!
analyse: aBlock
	| discoverer statisctics  |
	discoverer := self current. 
	discoverer startDiscovery.
	aBlock value.
	statisctics := discoverer stopDiscoveryAndGetStadistics.
	Transcript show: statisctics.! !

!UnusedObjectDiscoverer class methodsFor: 'as yet unclassified' stamp: 'Mariano 4/29/2010 17:53'!
current
	^ Current ifNil: [ Current := self new ]! !

!UnusedObjectDiscoverer methodsFor: 'stadistics' stamp: 'Mariano 4/27/2010 16:29'!
getStadistics
	| anArray stadistics|
	anArray := self primitiveGetStadistics.
	stadistics := UnusedObjectStadistics fromPrimitiveArray: anArray.
	^ stadistics ! !

!UnusedObjectDiscoverer methodsFor: 'primitives' stamp: 'Mariano 4/27/2010 14:47'!
primitiveGetStadistics 

	<primitive: 160>	"successful completion returns an Array with the stadistics numbers"
	^  self primitiveFailed 
! !

!UnusedObjectDiscoverer methodsFor: 'primitives' stamp: 'Mariano 3/31/2010 14:50'!
primitiveGetUsedBit: anObject

	<primitive: 163>	"successful completion returns self"
	^ self primitiveFailed ! !

!UnusedObjectDiscoverer methodsFor: 'primitives' stamp: 'Mariano 4/2/2010 16:19'!
primitiveMarkAllObjects 

	<primitive: 161>	"successful completion returns self"
	^  self primitiveFailed 
! !

!UnusedObjectDiscoverer methodsFor: 'primitives' stamp: 'Mariano 4/26/2010 15:23'!
primitiveMarkAsUsed: anObject
	^ self primitiveSetUsedBit: anObject boolean: true! !

!UnusedObjectDiscoverer methodsFor: 'primitives' stamp: 'Mariano 5/10/2010 20:25'!
primitiveSetHasToTrace: aBoolean

	<primitive: 159>	"successful completion returns self"
	^  self primitiveFailed 
! !

!UnusedObjectDiscoverer methodsFor: 'primitives' stamp: 'Mariano 3/31/2010 14:50'!
primitiveSetUsedBit: anObject boolean: aBoolean

	<primitive: 164>	"successful completion returns self"
	^  self primitiveFailed ! !

!UnusedObjectDiscoverer methodsFor: 'primitives' stamp: 'Mariano 4/2/2010 16:01'!
primitiveUnmarkAllObjects 

	<primitive: 162>	"successful completion returns self"
	^  self primitiveFailed 
! !

!UnusedObjectDiscoverer methodsFor: 'primitives' stamp: 'Mariano 4/26/2010 15:23'!
primitiveUnmarkAsUsed: anObject
	^ self primitiveSetUsedBit: anObject boolean: false! !

!UnusedObjectDiscoverer methodsFor: 'actions' stamp: 'Mariano 5/10/2010 22:07'!
startDiscovery
	self primitiveUnmarkAllObjects.
	self primitiveSetHasToTrace: true.
! !

!UnusedObjectDiscoverer methodsFor: 'actions' stamp: 'Mariano 5/11/2010 17:29'!
stopDiscovery
	self primitiveSetHasToTrace: false.! !

!UnusedObjectDiscoverer methodsFor: 'actions' stamp: 'Mariano 5/11/2010 17:29'!
stopDiscoveryAndGetStadistics
	| stadistics |
	self primitiveSetHasToTrace: false.
	stadistics := self getStadistics.
	^ stadistics! !

Object subclass: #UnusedObjectStadistics
	instanceVariableNames: 'unusedCount usedCount objectCount unusedPercentage usedPercentage usedMemory unusedMemory totalMemory percentageUsedMemory percentageUnusedMemory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnusedObject'!

!UnusedObjectStadistics class methodsFor: 'as yet unclassified' stamp: 'Mariano 5/4/2010 20:41'!
fromPrimitiveArray: anArray
	| usedCount unusedCount usedMemory unusedMemory objectsCount totalMemory |
	usedCount := (anArray at: 1).
	unusedCount := (anArray at: 2).
	usedMemory  := (anArray at: 3).
	unusedMemory  := (anArray at: 4).
	
	objectsCount := usedCount + unusedCount.
	totalMemory := unusedMemory + usedMemory.
	^ self new
		usedCount: usedCount;
		unusedCount: unusedCount;
		objectCount: objectsCount;
		unusedPercentage: ((unusedCount * 100) / objectsCount) asFloat;
		usedPercentage: ((usedCount * 100) / objectsCount) asFloat;
		usedMemory: usedMemory;
		unusedMemory: unusedMemory;
		totalMemory: totalMemory;
		percentageUnusedMemory: ((unusedMemory * 100) / totalMemory) asFloat;
		percentageUsedMemory: ((usedMemory * 100) / totalMemory) asFloat
		 ! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/27/2010 16:02'!
objectCount
	^ objectCount! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/27/2010 16:02'!
objectCount: anObject
	objectCount := anObject! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/29/2010 10:31'!
percentageUnusedMemory
	^ percentageUnusedMemory! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/29/2010 10:31'!
percentageUnusedMemory: anObject
	percentageUnusedMemory := anObject! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/29/2010 10:31'!
percentageUsedMemory
	^ percentageUsedMemory! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/29/2010 10:31'!
percentageUsedMemory: anObject
	percentageUsedMemory := anObject! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 5/4/2010 20:04'!
printOn: aStream
	aStream 
		nextPutAll: 'Total amount of objects: ', self objectCount asString, String cr;
		nextPutAll: 'Amount of used objects: ', self usedCount asString, String cr;
		nextPutAll: 'Percentage of used objects: ', self usedPercentage asString, String cr;
		nextPutAll: 'Amount of unused objects: ', self unusedCount asString, String cr;
		nextPutAll: 'Percentage of unused objects: ', self unusedPercentage asString, String cr;
		nextPutAll: String cr;
		nextPutAll: 'Total bytes of memory used: ', self totalMemory  asString, String cr;
		nextPutAll: 'Bytes of memory for the used objects: ', self usedMemory asString, String cr;
		nextPutAll: 'Percentage of memory for the used objects: ', self percentageUsedMemory asString, String cr;
		nextPutAll: 'Bytes of memory for the unused objects: ', self unusedMemory asString, String cr;
		nextPutAll: 'Percentage of memory for the unused objects: ', self percentageUnusedMemory asString, String cr.
	! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/29/2010 10:29'!
totalMemory
	^ totalMemory! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/29/2010 10:29'!
totalMemory: anObject
	totalMemory := anObject! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/27/2010 16:02'!
unusedCount
	^ unusedCount! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/27/2010 16:02'!
unusedCount: anObject
	unusedCount := anObject! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/29/2010 10:29'!
unusedMemory
	^ unusedMemory! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/29/2010 10:29'!
unusedMemory: anObject
	unusedMemory := anObject! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/27/2010 16:26'!
unusedPercentage
	^ unusedPercentage! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/27/2010 16:26'!
unusedPercentage: anObject
	unusedPercentage := anObject! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/27/2010 16:02'!
usedCount
	^ usedCount! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/27/2010 16:02'!
usedCount: anObject
	usedCount := anObject! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 5/17/2010 16:14'!
usedMemory
	^ usedMemory ! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/29/2010 10:29'!
usedMemory: anObject
	usedMemory := anObject! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/27/2010 16:26'!
usedPercentage
	^ usedPercentage! !

!UnusedObjectStadistics methodsFor: 'accessing' stamp: 'Mariano 4/27/2010 16:26'!
usedPercentage: anObject
	usedPercentage := anObject! !

!PackageInfo methodsFor: '*UnusedObject' stamp: 'Mariano 5/12/2010 14:03'!
classes
	^((self systemCategories gather:
		[:cat |
		(SystemOrganization listAtCategoryNamed: cat)
			collect: [:className | Smalltalk at: className]])
				sortBy: [:a :b | a className <= b className]) select: [:each | each isTrait not ]! !
